SystemOrganization addCategory: #'People-spfa-dragproxy'!


BorderedMorph subclass: #DragProxy
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-dragproxy'!

DragProxy class
	instanceVariableNames: ''!


!DragProxy commentStamp: 'spfa 9/27/2005 18:55' prior: 0!
Allow a simple implementation for dragging morphs with the Hand without having them change owner. Instead of directly grabbing the targetted morph, the hand is given a DragProxy whose position gets synchronized with the target.

see the 'drag proxy' methods in BreakPointHandle for a clear example of usage

!

!Morph methodsFor: '*People-spfa-dragproxy' stamp: 'spfa 10/18/2005 00:03'!
followDragProxyAt: aPoint! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 9/27/2005 16:44'!
initialize

	super initialize.
	self color: Color transparent.
	self borderColor: Color transparent! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 10/17/2005 23:53'!
justDroppedInto: aMorph event: anEvent

	self releaseTarget
! !

!DragProxy class methodsFor: 'as yet unclassified' stamp: 'spfa 9/27/2005 15:48'!
new: aMorph

	^ self new target: aMorph! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 5/5/2008 09:57'!
privateMoveBy: delta

	| evt |

	super privateMoveBy: delta.
	
	evt _ self currentEvent.
	(evt isDraggingEvent
		and: [evt anyButtonPressed]) ifFalse: [^ self releaseTarget].

	(owner notNil
		and: [owner isHandMorph]
		and: [target notNil])
	ifFalse: [^ self].

	target followDragProxyAt: (target globalPointToLocal: self center)! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 10/18/2005 15:59'!
releaseTarget

	target ifNotNil:
	[
		target stopBeingDraggedBy: self.
		target _ nil.
	].

	self delete.
! !

!Morph methodsFor: '*People-spfa-dragproxy' stamp: 'spfa 9/27/2005 16:08'!
startBeingDraggedBy: aDragProxy! !

!Morph methodsFor: '*People-spfa-dragproxy' stamp: 'spfa 9/27/2005 16:07'!
stopBeingDraggedBy: aDragProxy! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 3/13/2007 21:47'!
target

	^ target! !

!DragProxy methodsFor: 'as yet unclassified' stamp: 'spfa 9/27/2005 16:06'!
target: aMorph

	target _ aMorph.
	target startBeingDraggedBy: self! !
