


!TestBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 1/21/2007 20:13'!
defaultBrowserTitle
	"Returns the receivers default browser title"
	
	^self asString! !

!NCAAConnectorMorph class methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/14/2005 11:15'!
defaultFSM

	^ nil! !

!Point methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 11/6/2004 16:01'!
dist: aPoint 
	"Answer the distance between aPoint and the receiver."

	| dx dy |

	dx _ aPoint x - x.
	dy _ aPoint y - y.

	^ ((dx * dx) + (dy * dy)) sqrt! !

!FileList2 class methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/26/2005 14:50'!
initialize
	Preferences
		addPreference: #useFileList2
		categories:  #(general)
		default: true
		balloonHelp: 'if true, then when you open a file list from the World menu, it''ll be an enhanced one'
		projectLocal:  false
		changeInformee:  self
		changeSelector: #useFileList2preferenceChanged
		viewRegistry: PreferenceViewRegistry ofBooleanPreferences ! !

!FileContentsBrowser methodsFor: '*People-spfa-fixes' stamp: 'spfa 11/14/2004 20:42'!
isTestCase: aPseudoClass

	^ false! !

!ZipArchiveMember methodsFor: '*People-spfa-fixes-common' stamp: 'spfa 1/30/2007 16:53'!
localFileName
	"Answer my fileName in terms of the local directory naming convention"
	| localName |
	localName _  (fileName copyReplaceAll: '/' with: FileDirectory slash)
		copyReplaceAll: '\' with: FileDirectory slash.
	^(fileName first = $/)
		ifTrue: [ FileDirectory default class makeAbsolute: localName ]
		ifFalse: [ FileDirectory default class makeRelative: localName ]! !

!ExternalDropHandler methodsFor: '*People-spfa-fixes-override' stamp: 'spfa 5/25/2004 13:38'!
matchesExtension: aExtension
	(self extension isNil or: [aExtension isNil])
		ifTrue: [^false].
	FileDirectory activeDirectoryClass isCaseSensitive
		ifTrue: [^extension = aExtension]
		ifFalse: [^extension sameAs: aExtension]! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/23/2005 12:15'!
maybeBecomeNCLineMorph

	"for conversion from a connector v1.9 to a connector 2.2"

	| lw col o |

	(owner isNil or: [owner isConnector not]) ifTrue: [^ self].

	(owner isMGraphConnector and:
		[owner isTimeStamp]) ifTrue: [ lw _ 1] ifFalse: [lw _ 2].

	col _ borderColor.
	o _ owner.
	self privateOwner: nil.
	self become: ((NCLineMorph vertices: vertices lineWidth: lw lineColor: col borderWidth: 0 borderColor: col) privateOwner: o) 
		makeForwardArrow; fillStyle: col.

	owner beOrthogonal: false! !

!Object methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/22/2008 21:35'!
perform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!PolygonMorph methodsFor: '*People-spfa-fixes' stamp: 'spfa 4/27/2005 15:03'!
removeShortEndSegmentsStepping: something

	"used as a hook for on-the-fly conversion from a connector v1.9 to a connector 2.2"

	self maybeBecomeNCLineMorph.
	self removeShortEndSegmentsStepping: something! !

!Rectangle methodsFor: '*People-spfa-fixes' stamp: 'spfa 5/12/2006 14:16'!
storeOn: aStream 
	
	aStream nextPut: $(.
	self printOn: aStream.
	aStream nextPut: $)! !
