


!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 3/9/2007 22:17'!
aboutToBeGrabbedBy: aHand
	"Don't allow the receiver to act outside a Menu"

	(owner notNil and:[owner submorphs size = 1]) ifTrue:[
		"I am a lonely menuitem already; just grab my owner"
		owner stayUp: true.
		^owner 	aboutToBeGrabbedBy: aHand].
	^ self asMenu! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 10/20/2005 08:52'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	aCustomMenu add: 'add title...' translated action: #addTitle.
	aCustomMenu add: 'set target...' translated action: #setTarget:.
	defaultTarget ifNotNil: [
		aCustomMenu add: 'add item...' translated action: #addItem].
	aCustomMenu add: 'add line' translated action: #addLine.
	(self items count:[:any| any hasSubMenu]) > 0
		ifTrue:[aCustomMenu add: 'detach submenu' translated action: #detachSubMenu:].
		
	aCustomMenu addLine;
		add: 'detaching a submenu' translated target: self class selector: #howToDetach! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 3/9/2007 22:13'!
asMenu

	| menu |

	menu _ MenuMorph new defaultTarget: nil.
	menu addMorphFront: self.
	menu bounds: self bounds.
	menu stayUp: true.
	self isSelected: false.
	^menu! !

!MenuMorph methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 3/13/2004 23:17'!
detach

	popUpOwner ifNil: [^ self].

	popUpOwner isSelected: false.
	popUpOwner subMenu: self veryDeepCopy.
	popUpOwner owner activeSubmenu: nil.
	popUpOwner owner stayUp ifFalse: [popUpOwner owner delete].
	
	self stayUp: true.
"	self addTitle: popUpOwner contents."
	self popUpOwner: nil.
	self selectItem: nil event: nil.
	
	self topLeft: ActiveHand position.
	ActiveHand grabMorph: self

		
! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 3/13/2004 23:36'!
detachExample

	| example subExample1 subSubExample subExample2 |

	example _ MenuMorph new.
	
	(subExample1 _ MenuMorph new)
		add: 'dummy' action: nil;
		add: 'void' action: nil.
	
	(subSubExample _ MenuMorph new)
		add: 'nope' action: nil;
		add: 'nada' action: nil;
		add: 'niet' action: nil.
	
	(subExample2 _ MenuMorph new)
		add: 'useless' action: nil;
		add: 'more of it' subMenu: subSubExample.
		
	example
		add: 'sub 1' subMenu: subExample1;
		add: 'sub 2' subMenu: subExample2;
		add: 'that''s it' action: nil.
		
	example popUpInWorld! !

!MenuMorph class methodsFor: '*People-spfa-strip-menu' stamp: 'spfa 5/24/2004 15:05'!
howToDetach

	'
	examples:
	
		MenuMorph detachExample "doIt for each example below"
	
	
	
	to detach the ''sub 1'' submenu, yellow click ''sub 1'' and drag to the right.
	to detach the ''sub 1'' item, blue click it twice and use the black halo.
	to detach ''that''s it'', yellow click it
	to detach the ''more of it'' submenu, yellow click ''more of it'' and drag to the right.
	to detach the ''more of it'' item, blue click it twice and use the black halo.
		
	' displayWithLabel: 'how to detach a submenu'! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 9/27/2005 12:34'!
mouseDown: evt
	"Handle a mouse down event. Menu items get activated when the mouse is over them."

	(evt yellowButtonPressed & self hasSubMenu not and: [owner isSticky not])
		ifTrue: [self delete; topLeft: ActiveHand position.
				  ActiveHand grabMorph: self.
			      self isSelected: false].

	evt shiftPressed ifTrue: [^ super mouseDown: evt].  "enable label editing" 
	evt hand newMouseFocus: owner. "Redirect to menu for valid transitions"
	owner selectItem: self event: evt. 
! !

!MenuItemMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 3/13/2004 21:10'!
mouseEnterDragging: evt
	"The mouse entered the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	evt yellowButtonPressed ifTrue: [owner detach].
	
	evt hand mouseFocus == owner ifTrue:[owner selectItem: self event: evt]! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 5/27/2008 14:18'!
popUpAdjacentTo: rightOrLeftPoint forHand: hand from: sourceItem 
	"Present this menu at the given point under control of the given  
	hand."
	| delta tryToPlace selectedOffset |
	hand world startSteppingSubmorphsOf: self.
	popUpOwner := sourceItem.
	self fullBounds.
self updateColor.
	"ensure layout is current"
	selectedOffset := (selectedItem
				ifNil: [self items middle]) position - self position.
	tryToPlace := [:where :mustFit | 
			self position: where - selectedOffset.
			delta := self fullBoundsInWorld amountToTranslateWithin: sourceItem worldBounds.
			(delta x = 0
					or: [mustFit])
				ifTrue: [delta = (0 @ 0)
						ifFalse: [self position: self position + delta].
					sourceItem owner owner addMorphFront: self.
					^ self]].
	tryToPlace value: rightOrLeftPoint first value: false;
		 value: rightOrLeftPoint last - (self width @ 0) value: false;
		 value: rightOrLeftPoint first value: true! !

!MenuMorph methodsFor: '*People-spfa-strip-menu-override' stamp: 'spfa 8/29/2005 22:36'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph.  A single-item MenuMorph is in effect a button rather than a menu, and as such should not be reluctant to be dropped into another object."

	^ (aMorph isWorldMorph or: [submorphs size == 1]) or:
		[Preferences systemWindowEmbedOK] or:
		[aMorph wantsDroppedMenu]
! !
