SystemOrganization addCategory: #'People-spfa-utils'!
SystemOrganization addCategory: #'People-spfa-utils-for-menu'!


BorderedMorph subclass: #MouseInputArea
	instanceVariableNames: 'balloonText messageSend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea subclass: #DropReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea subclass: #SensitiveArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

DropReporter subclass: #TransferGetter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'People-spfa-utils'!

MouseInputArea class
	instanceVariableNames: ''!

DropReporter class
	instanceVariableNames: ''!

SensitiveArea class
	instanceVariableNames: ''!

TransferGetter class
	instanceVariableNames: ''!


!DropReporter commentStamp: '<historical>' prior: 0!
usage:

	(DropReporter sendMorphTo: receiver via: selector) openInWorld

any morph dropped in the DropReporter is sent to receiver via selector, then the morph is rejected to its previous position and the DropReporter disappear (to make it permanent, double-click inside: the border becomes green, and more than one morph can be dropped).

receiver can be nil, in which case selector is sent to the morph itself.

examples:

	(DropReporter sendMorphTo: nil via: #collapse) openInWorld

	(DropReporter sendMorphTo: (Lambda m color: Color red) via: #value:) openInWorld

	(DropReporter sendMorphTo: [:m | m explore] via: #value:) openInWorld!

!MouseInputArea commentStamp: 'spfa 3/11/2004 09:35' prior: 0!
A labelled rectangular area triggering a MessageSend upon specific mouse activity.

The area may disappear after action (it is not "permanent") or even disappear after a few seconds whatever happens (it is then "temporary")

This abstract class does not implement event handling. See subclasses.

!

!SensitiveArea commentStamp: 'spfa 3/11/2004 09:58' prior: 0!
This area evaluate its MessageSend upon mouseEnter!

!DropReporter methodsFor: 'event handling' stamp: 'spfa 6/12/2003 11:16'!
acceptDroppingMorph: dropee event: evt 

	| ms |

	dropee wasReported.
	dropee rejectDropMorphEvent: evt.
	dropee wasRejected.

	ms _ messageSend.
	ms receiver ifNil: [ms receiver: dropee].

	(ms valueWithArguments: {dropee})
		ifNil: [^ self]. 	"if receiver sent nil back, it didn't like the dropee. so stay alive and wait for the next one"

	(self hasProperty: #permanent)
		ifFalse: [self delete]! !

!TransferGetter methodsFor: 'as yet unclassified' stamp: 'spfa 1/8/2006 22:11'!
acceptDroppingMorph: dropee event: evt 

	| ms passenger |

	passenger _ dropee passenger.

	ms _ messageSend.
	ms receiver ifNil: [ms receiver: passenger].

	(ms valueWithArguments: {passenger})
		ifNil: [^ self]. 	"if receiver sent nil back, it didn't like the dropee. so stay alive and wait for the next one"

	(self hasProperty: #permanent)
		ifFalse: [self delete]! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:22'!
accumulatedRuns

	| d |

	d _ 0.

	^ runs collect: [:r | d _ d + r]! !

!RunArray methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 15:24'!
accumulatedRunsAndValuesDo: aBlock

	^ self accumulatedRuns with: values do: aBlock.! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:43'!
activateSubmenu: evt
	"Activate our submenu; e.g., pass control to it"

	self subMenu ifNil:[^false]. "not applicable"
	(self subMenu fullContainsPoint: evt position) ifFalse:[^false].
	self subMenu activate: evt.
	self removeAlarm: #deselectTimeOut:.
	^true! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 09:31'!
actualSubMenu

	^ self valueOfProperty: #actualSubMenu! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 09:31'!
actualSubMenu: aMenuMorph

	self setProperty: #actualSubMenu toValue: aMenuMorph! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 2/6/2007 14:49'!
add: aString dynamicSubMenu: aSymbolOrLambda
	"Append the given submenu with the given label."

	| ms |

	ms _ aSymbolOrLambda.
	ms isSymbol ifTrue: 
		[ms _ MessageSend receiver: defaultTarget selector: aSymbolOrLambda].

	self
		add: aString
		subMenu: ms! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/17/2005 14:27'!
add: aString forkAction: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the default target object in a separate thread."

	self add: aString
		target: (MessageSend receiver: defaultTarget selector: aSymbol)
		selector: #fork
		argumentList: EmptyArray.! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 2/9/2007 11:00'!
add: aString getter: getter dropToSetter: setter then: last

	| lambdaGetter lambdaSetter lastLambda |

	lambdaGetter _ self makeLambdaFrom: getter.
	lambdaSetter _ self makeLambdaFrom: setter.
	lastLambda _ self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #deliverMorphicArgumentFor:withString:initialAnswer:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/16/2008 09:49'!
add: aString getter: getter dropToSetter: setter withDependents: anArray then: last

	| lambdaGetter lambdaSetter lastLambda |

	lambdaGetter _ self makeLambdaFrom: getter.
	lambdaSetter _ self makeLambdaFrom: setter.
	lastLambda _ self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #deliverMorphicArgumentFor:withString:initialAnswer:morphDependents:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . anArray . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:28'!
add: aString getter: aSelector lambdaSetter: bSelector

	self add: aString getter: aSelector lambdaSetter: bSelector target: defaultTarget! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString 

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: defaultTarget then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: qString target: anObject then: cSelector

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> (anObject lambda: aSelector)))
	 target: self
	 selector: #lambdaParseArgumentFor:inBehalfOf:withString:initialAnswer:then:
	 argumentList: {bSelector . anObject . qString . aSelector . cSelector}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:28'!
add: aString getter: aSelector lambdaSetter: bSelector target: anObject

	self add: aString getter: aSelector lambdaSetter: bSelector target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
add: aString getter: aSelector lambdaSetter: bSelector target: anObject then: cSelector

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: aString target: anObject then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
add: aString getter: aSelector lambdaSetter: bSelector then: cSelector

	^ self add: aString getter: aSelector lambdaSetter: bSelector queryPrompt: aString target: defaultTarget then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/28/2003 14:00'!
add: aString getter: aSelector setter: bSelector

	self add: aString getter: aSelector setter: bSelector target: defaultTarget! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/24/2008 10:35'!
add: aString getter: getter setter: setter morphQuery: m morphAddDependents: anArray then: last

	| lambdaGetter lambdaSetter lastLambda mLambda |

	lambdaGetter _ self makeLambdaFrom: getter.
	lambdaSetter _ self makeLambdaFrom: setter.
	mLambda _ self makeLambdaFrom: m.
	lastLambda _ self makeLambdaFrom: last.

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> lambdaGetter))
		 target: self
		 selector: #queryMorphicArgumentFor:withString:initialAnswer:initialMorphicLambda:morphDependents:thenDo:
		 argumentList: {lambdaSetter . aString . lambdaGetter . mLambda . anArray  . lastLambda}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/6/2004 09:22'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString 

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: defaultTarget then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/15/2004 10:39'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
add: aString getter: aSelector setter: bSelector queryPrompt: qString target: anObject then: cSelector

	self addUpdatingLambda: (self lambda makeGetterSetterWordingFrom: 
								(aString -> (anObject lambda: aSelector)))
		 target: self
		 selector: #queryArgumentFor:inBehalfOf:withString:initialAnswer:then:
		 argumentList: {bSelector . anObject . qString . aSelector . cSelector}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/28/2003 14:21'!
add: aString getter: aSelector setter: bSelector target: anObject

	self add: aString getter: aSelector setter: bSelector target: anObject then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/6/2004 10:51'!
add: aString getter: aSelector setter: bSelector target: anObject then: cSelector

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: aString target: anObject then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 12/1/2004 14:53'!
add: aString getter: aSelector setter: bSelector then: cSelector

	^ self add: aString getter: aSelector setter: bSelector queryPrompt: aString target: defaultTarget then: cSelector! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 11:49'!
add: aString getter: gSymbol setter: aSymbol withIntSlider: anInterval

	^ self 
		add: aString getter: gSymbol setter: aSymbol;
		addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol truncate: true
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 11:37'!
add: aString getter: gSymbol setter: aSymbol withSlider: anInterval

	^ self 
		add: aString getter: gSymbol setter: aSymbol;
		addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/15/2006 13:25'!
add: aString lambda: aLambdaMessageSend

	self add: aString target: aLambdaMessageSend action: #value! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/30/2005 20:27'!
add: aString selector: aSymbol argumentList: arg

	self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: arg
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/24/2005 20:25'!
add: aString toggleForProperty: aSymbol
	
	self add: aString toggleForProperty: aSymbol target: defaultTarget
			  				  ! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
add: aString toggleForProperty: aSymbol target: aMorph
	
	self addUpdatingLambda: ((aMorph lambda hasProperty: aSymbol) yesNoString, aString)
		  target: aMorph
		  selector: #toggleProperty: 
		  argumentList: {aSymbol}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/24/2005 20:27'!
add: aString toggleForProperty: aSymbol then: bSymbol

	self add: aString 
		toggleForProperty: aSymbol 
		then: bSymbol 
		target:  defaultTarget
			  				  ! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
add: aString toggleForProperty: aSymbol then: bSymbol target: aMorph

	self addUpdatingLambda:
			((aMorph lambda hasProperty: aSymbol) yesNoString, aString)
		  target: aMorph
		  selector: #toggleProperty:then:
		  argumentList: {aSymbol . bSymbol}.! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/5/2004 15:22'!
add: aListOfAssociations valuesForProperty: aSymbol 

	^ self add: aListOfAssociations valuesForProperty: aSymbol then: #yourself! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
add: aListOfAssociations valuesForProperty: aSymbol then: bSymbol

	aListOfAssociations do: [:ea |
	self addUpdatingLambda: 
			(((defaultTarget lambda valueOfProperty: aSymbol) quoted = ea value)
 				yesNoString, ea key)
		target: defaultTarget
		selector: #setProperty:toValue:then: 
		argumentList: {aSymbol . ea value . bSymbol}	]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 08:33'!
add: aString watchingBoolean: aMessageSend selector: sSymbol argument: arg
	
	self add: aString watchingBoolean: aMessageSend target: defaultTarget selector: sSymbol argumentList: {arg}! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
add: aString watchingBoolean: aLambdaBoolean target: anObject selector: sSymbol argumentList: anArray
	
	self addUpdatingLambda: (aLambdaBoolean yesNoString, aString)
		  target: anObject
		  selector: sSymbol 
		  argumentList: anArray! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/15/2006 13:55'!
addChoice: aList getter: gSymbol setter: sSymbol

	aList do: [:s |
		self add: s asString
			watchingBoolean: 
				((defaultTarget lambda: gSymbol) lambda: #== with: s)
	 		selector: sSymbol 
			argument: s]
	
! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2004 22:05'!
addCloseBox
	
	(labelArea isNil or: [self wantsCloseBox])
		ifTrue: [^ super addCloseBox].
	
	closeBox := (BorderedMorph new) color: Color transparent; extent: 0@0.
	labelArea addMorph: closeBox! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:52'!
addFastUpdatingLabel: aString watching: aLambda

	(self 
	addUpdating: #value 
	target: (aString lambda, aLambda quoted withMenuPrecision quoted asString)
	selector: #ignore 
	argumentList: #()) getProperty: #fast
	! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/28/2004 21:17'!
addFirstItems: anArray

	self addFirstLabels: (anArray inject: '' into: [:string :spec | 
		string _ string, String cr, spec first]) allButFirst.
	self addFirstSelections: (anArray collect: [:spec | spec second])! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/28/2004 21:10'!
addFirstLabels: aString

	| offset |

	offset _ (aString occurrencesOf: Character cr) + 1.

	lineArray _ {offset}, (lineArray collect: [:i | i + offset]).
	labelString _ aString, String cr, labelString! !

!SelectionMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/28/2004 21:08'!
addFirstSelections: anArray

	selections _ anArray, selections! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/13/2004 11:26'!
addLabel: aString

	self add: aString asString target: nil selector: #isNil! !

!PopUpMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/28/2004 21:04'!
addLabels: aString

	lineArray _ lineArray, {self nItems}.
	labelString _ labelString, String cr, aString.! !

!SelectionMenu methodsFor: '*People-spfa-utils' stamp: 'spfa 11/28/2004 20:58'!
addSelections: anArray

	selections _ selections, anArray! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/12/2004 15:25'!
addService: aService

	self addService: aService for: nil! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/12/2004 15:53'!
addServices: aListOfServices

	aListOfServices do: [:service | self addService: service]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/25/2005 22:47'!
addSlider: anInterval getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/25/2005 23:21'!
addSlider: anInterval label: aString getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: aString target: defaultTarget getter: gSymbol setter: aSymbol 
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/9/2005 15:03'!
addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol truncate: false

! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 11:55'!
addSlider: anInterval label: aString target: target getter: gSymbol setter: aSymbol truncate: aBoolean

	| item slider |
	slider _ (SimpleSliderMorph new target: target;
				 actionSelector: aSymbol;
				 truncate: aBoolean;
				 minVal: anInterval start;
				 maxVal: anInterval end;
				 adjustToValue: (target perform: gSymbol);
				 color: Preferences menuTitleColor;
				 sliderColor: Preferences menuTitleColor darker;
				 extent: ((anInterval extent max: 150) min: 200) @ 10).
	item _ MenuItemMorph new contents: aString.
	self addMorphBack: item.
	item addMorph: slider.
	^ item
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/25/2005 23:21'!
addSlider: anInterval target: target getter: gSymbol setter: aSymbol 

	^ self addSlider: anInterval label: ' ' target: target getter: gSymbol setter: aSymbol 
! !

!Morph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 12/2/2004 14:00'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' translated action: #goBehind.
		aMenu add: 'bring to front' translated action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu addLine].

	aMenu 	
		add: 'send to project...' translated action: #sendToAnotherProject;
		add: 'copy to project...' translated action: #copyToAnotherProject;
		addLine.

	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph.
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	self addHaloActionsTo: aMenu.
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addPlayerItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.
	self addStackItemsTo: aMenu.
	self addMiscExtrasTo: aMenu.
	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu
			add: ('unlock "{1}"' translated format: unlockables first externalName)
			action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' translated action: #unlockContents.
		aMenu add: 'unlock...' translated action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 6/4/2004 16:12'!
addSubclassesOf: aMorphClass

"
	add an item for registered subclasses of aMorphClass, allowing to open an instance in Hand.

	the registration is done on the class side through:
	#idString	-> when not nil (a String), make an item with that label
	#instanceTypes  -> when not-nil (a Dictionary), make a submenu with keys as labels and values as nativity selectors
	#partsBinSubmenuHeader -> when present (returns a String) make a submenu for all subclasses. 
"

	aMorphClass subclasses do: [:ea |

	(ea idString notNil 
		and: [(ea class includesSelector: #partsBinSubmenuHeader) not])
	ifTrue: 
	[
		| itypes |
		(itypes _ ea instanceTypes)
		ifNil: [self add: (ea idString) 
						 target: ea 
						 selector: #asNewMorphInHand]
		ifNotNil: [self add: (ea idString, ' ') subMenu: (ea instanceTypesMenu)].
		self addSubclassesOf: ea
	]
	ifFalse:
	[
		(ea class includesSelector: #partsBinSubmenuHeader) 
	 	ifTrue: 
	 	[
			ea partsBinSubmenuHeader
			ifNotNil: [	| m |
						m _ MenuMorph new.
						ea idString 
						ifNotNil: [m add: (ea idString) 
									 target: ea 
						 			 selector: #asNewMorphInHand].
  		 				m addSubclassesOf: ea.
						self add: (ea partsBinSubmenuHeader, ' ') subMenu: m]
		]
		ifFalse: [self addSubclassesOf: ea]
	]]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/11/2003 20:44'!
addToggleForProperty: aSymbol

	self add: aSymbol asString toggleForProperty: aSymbol! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 2/9/2007 09:34'!
addUpdatingLabel: aString watching: aLambda

	self 
	addUpdating: #value 
	target: (aString lambda, aLambda quoted withMenuPrecision quoted asString)
	selector: #ignore 
	argumentList: #()
	! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/27/2007 15:08'!
addUpdatingLabel: aString watching: aLambdaExpression action: aSelector

	self addUpdatingLabel: aString watching: aLambdaExpression action: aSelector target: defaultTarget
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/27/2007 15:06'!
addUpdatingLabel: aString watching: aLambdaExpression action: aSelector target: anObject

	self addUpdatingLambda: 
			(aString lambda sformat: aLambdaExpression) 
		target: anObject
		selector: aSelector
		argumentList: #()! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 14:45'!
addUpdatingLambda: wordingLambda target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument.  In this variant, the wording of the menu item is obtained by evaluating the wordingLambda (a MessageSend or LambdaMessageSend). Answer the item added."

	| item |
	item _ UpdatingMenuItemMorph new
		target: target;
		selector: aSymbol;
		wordingProvider: wordingLambda wordingSelector: #value;
		arguments: argList asArray.
	self addMorphBack: item.
	^ item
! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 4/21/2005 21:19'!
allButFirstAndLast

	^ self copyFrom: 2 to: self size - 1! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/17/2003 14:16'!
allFontsBecome: aFont

	self allMorphsDo: [:m |
		(m respondsTo: #font:) 
			ifTrue: [m font: aFont]].

	self changed
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/19/2003 14:34'!
allFontsToDefault

	self allFontsBecome: TextStyle defaultFont.
	self changed

! !

!Process class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/22/2004 20:33'!
allNamed: aString

	^ self allInstances select: [:p | p name = aString]! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:43'!
allWordingsNotInSubMenus: verbotenSubmenuContentsList
	"Answer a collection of the wordings of all items and subitems, but omit the stay-up item, and also any items in any submenu whose tag is in verbotenSubmenuContentsList"

	self isStayUpItem ifTrue:[^ #()].
	self subMenu ifNotNil:
		[^ (verbotenSubmenuContentsList includes: self contents asString)
			ifTrue:
				[#()]
			ifFalse:
				[self subMenu allWordingsNotInSubMenus: verbotenSubmenuContentsList]].

	^ Array with: self contents asString! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 22:25'!
analyseDifferenceAfter: aBlock 

	self analyseDifferenceAfter: aBlock forClasses: Smalltalk allClasses.
! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 22:25'!
analyseDifferenceAfter: aBlock forClasses: classes

	| before after |

	before _ SpaceTally new preAllocateResultsFor: classes.
	after _ SpaceTally new preAllocateResultsFor: classes.
	Smalltalk garbageCollect.
	before computeSpaceUsageWithProgress:  'first pass...'.
	aBlock value.
	Smalltalk garbageCollect.
	after computeSpaceUsageWithProgress: 'second pass...'.
	SpaceTally compare: before to: after ! !

!Symbol methodsFor: '*People-spfa-utils' stamp: 'spfa 12/19/2004 10:08'!
arity

	^ (self occurrencesOf: $:)! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2008 15:42'!
asB64

	"'Hi there!!' asB64"

	| ss | 

	ss _ ReadWriteStream on: (String new).
	ss nextPutAll: self.

	^ (Base64MimeConverter mimeEncode: ss) contents asOneLine.
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 3/24/2005 18:00'!
asB64

	^ self asString asB64! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:44'!
asBoldText

	^ (Text fromString: self) 
		addAttribute: (TextEmphasis bold)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/3/2004 13:38'!
asButton

	| label |

	label _ (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
		whenEmpty: [^ self].

	(MenuMorph new add: label	target: self action: #openInHand)
		stayUp: true; openInHand! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asCodeText

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: self);
		addAttribute: (TextColor blue)! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asEvalText: someCode

	^ (Text fromString: self) 
		addAttribute: (TextDoIt evalString: someCode);
		addAttribute: (TextColor blue)! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asExplicitEvalText: someCode

	^ (self asEvalText: someCode),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt  
							evalString: '''', someCode asB64, ''' openB64InWorkspace');
		addAttribute: (TextColor magenta))! !

!Float methodsFor: '*People-spfa-utils' stamp: 'spfa 3/26/2005 11:01'!
asFractionPrecision: aNumber

	| pot |

	pot _ 10 raisedTo: aNumber.
	^ ((self precision: aNumber) * pot) rounded asFraction / pot! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asMGraphDocText

	| txt |

	txt _ self asText.

	(MGraph classes collect: [:ea | ea asString])
		do: [:ea | | c |
				(c _ txt findString: ea startingAt: 1)
					isZero ifFalse: 
					[txt addAttribute: (TextDoIt evalString: (ea, ' showDocumentation'))
						  from: c to: (c + ea size).
					 txt addAttribute: (TextColor magenta) from: c to: (c + ea size).]].

	^ txt! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/4/2004 16:12'!
asNewMorphInHand

	^ self new asMorph openInHand! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asNumberOrZero

	"properly reads a float number missing an initial 0, as '.4'"

	^ [self asNumber] 
		on: Error 
		do: [
				(self allButFirst, ' ') asNumber. "if it fails, accept the failure !!"
				('0', self) asNumber "else maybe this will do, as in .2 -> 0.2"
			]	! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2008 15:42'!
asOneLine

	^ self reject:[:each | each == Character cr]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 9/26/2005 11:28'!
asTextColor: aColor

	^ (Text fromString: self) 
		addAttribute: (TextColor color: aColor)! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
asTextThatSend: aSelector toClass: aClass 

	| scl ssel |

	scl _ aClass asString.
	ssel _ aSelector asString.

	^ (self asEvalText: scl, ' perform:#', ssel),
	((Text fromString: ' (code)') 
		addAttribute: (TextDoIt evalString: 'Browser fullOnClass: ', scl, ' class selector: #', ssel);
		addAttribute: (TextColor magenta))! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/21/2004 10:14'!
atOrigin

	^ 0@0! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 3/11/2004 09:15'!
balloonText

	^ balloonText! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
balloonText: aText

	balloonText _ aText! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 5/31/2004 22:11'!
bePermanent

	self getProperty: #permanent.
	self borderColor: Color green muchDarker
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 3/11/2004 09:15'!
beSmall

	self 
		 extent: 80@50;
		borderWidth: 1.
		
	! !

!MouseInputArea methodsFor: 'options' stamp: 'spfa 5/31/2004 22:11'!
beTemporary

	self getProperty: #temporary.
	
	! !

!PluggableTextMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/3/2004 11:21'!
benchIt
	| result |
	self handleEdit:
		[result _ textMorph editor compileSelectionAsBlock.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [^self flash]].

	self inform: result bench! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/14/2005 11:01'!
book

	BookMorph allSubInstances do: [:b |
		(b pages includes: self) ifTrue: [^ b]].

	^ nil! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/16/2004 09:50'!
bottomCenter: aPoint

	self center: aPoint.
	self bottom: aPoint y! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/31/2005 11:58'!
bringBackOutsideMorphs

	"moves all morphs which bounds are not contained within the receiver bounds"

	(self submorphs 
		select: [:m | ((bounds extendBy: 1) containsPoint: m bounds corner) not])
	do: [:m | m setConstrainedPosition: m position hangOut: false ]! !

!CollapsedMorph methodsFor: '*People-spfa-utils-override' stamp: 'spfa 12/1/2004 00:11'!
buildWindowMenu
	"Answer the menu to be put up in response to the user's clicking on the window-menu control in the window title.  Specialized for CollapsedMorphs."

	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu add: 'change name...' translated action: #relabel.
	aMenu add: 'expand' translated action: #collapseOrExpand.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.	
	aMenu add: 'send to project...' translated action: #sendToAnotherProject.
	aMenu add: 'copy to project...' translated action: #copyToAnotherProject.
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	^aMenu! !

!SystemWindow methodsFor: '*People-spfa-utils-override' stamp: 'spfa 10/21/2005 13:38'!
buildWindowMenu
	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu add: 'change title...' translated action: #relabel.
	aMenu addLine.
	aMenu add: 'send to back' translated action: #sendToBack.
	aMenu add: 'make next-to-topmost' translated action: #makeSecondTopmost.
	aMenu addLine.	
	aMenu add: 'send to project...' translated action: #sendToAnotherProject.
	aMenu add: 'copy to project...' translated action: #copyToAnotherProject.
	aMenu addLine.
	aMenu add: self documentationReference notNil yesNoString, 'is documentation' 
		action: #toggleDocumentationStatus.
	aMenu add: 'documentation settings' action: #beDocumentation.
	aMenu addLine.
	self mustNotClose
		ifFalse:
			[aMenu add: 'make unclosable' translated action: #makeUnclosable]
		ifTrue:
			[aMenu add: 'make closable' translated action: #makeClosable].
	aMenu
		add: (self isSticky ifTrue: ['make draggable'] ifFalse: ['make undraggable']) translated 
		action: #toggleStickiness.
	aMenu addLine.
	aMenu add: 'full screen' translated action: #fullScreen.
	self isCollapsed ifFalse: [aMenu add: 'window color...' translated action: #setWindowColor].
	^aMenu! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 6/12/2003 14:59'!
buttonMaker

	^ (self sendMorphTo: nil via: #asButton) bePermanent label: '-> button'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/26/2004 20:24'!
buttonName

	^ self knownName ifNil: [self name]! !

!UpdatingMenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 13:26'!
changed

	super changed.
	(target isMorph and: [target isMenu])
		ifTrue: [target defaultTarget changed]! !

!SketchEditorMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/2/2005 22:31'!
clearEnclosingPasteUpMorph
	enclosingPasteUpMorph _ nil! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 4/2/2004 20:04'!
closeTo: aPoint

	^ (x closeTo: aPoint x) and: [y closeTo: aPoint y]! !

!SpaceTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 22:44'!
compare: before to: after

	| diffSpace |

	before results size ~= after results size 
		ifTrue: [self error: 'different sets of classes are not supported yet'].

	diffSpace _ 0.

	(StringHolder new contents: (String streamContents: 
			[:s | 
			before results with: after results do: [:bitem :aitem |
				bitem spaceForInstances = aitem spaceForInstances ifFalse:
				[
					bitem printOn: s.
					s cr.
					aitem printOn: s.
					s cr;cr.
					diffSpace _ diffSpace + (aitem spaceForInstances - bitem spaceForInstances).

				]].
			s nextPutAll: ('Total difference: %s bytes' sformat: diffSpace)]))
		openLabel: 'Differential Space Analysis'.
		! !

!SpaceTally methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 21:51'!
computeSpaceUsageWithProgress: aString

	| n |

	n _ 0.

	aString
	displayProgressAt: Sensor cursorPoint
	from: 0 to: results size
	during: [:bar |
		| entry c instanceCount |
		1 to: results size do: [:i |
			entry := results at: i.
			c := self class environment at: entry analyzedClassName.
			instanceCount _ c instanceCount.
			entry codeSize: c spaceUsed.
			entry instanceCount: instanceCount.
			entry spaceForInstances: (self spaceForInstancesOf: c withInstanceCount: instanceCount).
			bar value: (n _ n+1).
			Smalltalk garbageCollectMost]].
	
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2004 13:47'!
copyToAnotherProject

	| target |
	
	target _ Project queryProject ifNil: [^ self].
	target world addMorph: self veryDeepCopy! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/3/2008 09:20'!
debugDisplay

	| canvas |

	canvas _ FormCanvas extent: 2000@1000.
	self drawOn: canvas
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2005 13:38'!
defaultFileName

	(self documentationReference notNil and:
		[self documentationReference file notNil])
	ifTrue: [^ self documentationReference file].

	^ ('my ', self class name) asFileName! !

!BlobMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/2/2005 23:29'!
deleteAll
	AllBlobs _ nil! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 09:31'!
deleteSubMenu

	self subMenu delete.
	self actualSubMenu: nil.
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/16/2008 09:49'!
deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda morphDependents: anArray thenDo: lastLambda

	| o |

	o _ GenericInputMorph request: aString 
			initialAnswer: iLambda lambdaValue asString
			initialMorphicLambda: Lambda morph deliver etaAbstracted
			morphDependents: anArray
			test: (Lambda morph transportsA: LambdaMessageSend).

	o isString ifTrue:
	[ 
		o ifEmpty: [^ self].
		o _ Compiler evaluate: o
	].

	aLambdaExpression withUnlimitedEvaluation valueWithArguments: {o value}.
	lastLambda value

! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/16/2008 09:45'!
deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda thenDo: lastLambda

	self deliverMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda morphDependents: #() thenDo: lastLambda


! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:42'!
deselect: evt
	self isSelected: false.
	self subMenu ifNotNil: [
		owner ifNotNil:[owner activeSubmenu: nil. self deleteSubMenu].
		self removeAlarm: #deselectTimeOut:].! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 08:52'!
deselectItem
	| item |
	self isSelected: false.
	self hasSubMenu ifTrue: [self subMenu deleteIfPopUp].
	(owner isKindOf: MenuMorph) ifTrue:
		[item _ owner popUpOwner.
		(item isKindOf: MenuItemMorph) ifTrue: [item deselectItem]].
! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
displayWithLabel: aString 

	self asText displayWithLabel: aString ! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/24/2004 15:02'!
displayWithLabel: aString 

	self displayWithLabel: aString onColor: Color tan darker.
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/24/2004 15:00'!
displayWithLabel: aString onColor: aColor
	"Open up a system window with the receiver as its contents, with the given title"

	| w |

	w _ SystemWindow labelled: aString.
	w paneColor: aColor.
	w addMorph: (PluggableTextMorph on: self text: #asText accept: nil) frame: (0@0 corner: 1@1).

	w openInWorld
! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
doButtonAction
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	| t |

	t _ target lambdaValue.

	(t notNil and: [actionSelector notNil]) 
		ifTrue: 
			[Cursor normal 
				showWhile: [t perform: actionSelector withArguments: arguments].
			t isMorph ifTrue: [t changed]]! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
doButtonAction: evt
	| moreArgs |
	"Perform the action of this button. Subclasses may override this method. The default behavior is to send the button's actionSelector to its target object with its arguments."

	target ifNil: [^self].
	actionSelector ifNil: [^self].
	Cursor normal showWhile: [
		moreArgs _ actionSelector numArgs > arguments size ifTrue: [
			arguments copyWith: evt
		] ifFalse: [
			arguments
		].
		target lambdaValue perform: actionSelector withArguments: moreArgs
	]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/12/2007 15:05'!
doThen

	| then |

	then _ (self valueOfProperty: #then) ifNil: [^ self].

	then isSymbol 
		ifTrue: [defaultTarget perform: then]
		ifFalse: [then value]
	! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 12/3/2005 17:01'!
doWhileWaitingFor: aDuration

	"wait for aDuration and evaluate the receiver in the meantime if possible, else evaluate it anyway (in wich case more time than aDuration will have elapsed by the end of the method)"

	| dt |

	dt _ (aDuration - [self value] durationToRun).
	dt negative ifFalse: [dt asDelay wait].

	^ dt negated
! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 12/3/2005 16:38'!
doWhileWaitingFor: aDuration onFailure: bBlock

	^ self doWhileWaitingFor: aDuration onSuccess: [:dt | dt] onFailure: bBlock

! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 12/3/2005 16:43'!
doWhileWaitingFor: aDuration onSuccess: aBlock onFailure: bBlock

	| dt |

	^ (dt _ self doWhileWaitingFor: aDuration) negative 
		ifTrue: [aBlock value: dt] 
		ifFalse: [bBlock value: dt]
! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 6/5/2003 00:37'!
doubleClick: evt

	self bePermanent.
! !

!DropReporter methodsFor: 'drawing' stamp: 'spfa 4/24/2008 11:16'!
drawOn: aCanvas

	| innerRectangle |

	innerRectangle _ self bounds expandBy: 
							((self height min: self width) /// 3) asInteger negated.

	super drawOn: aCanvas.
	aCanvas line: self topLeft to: innerRectangle topLeft color: Color grey.
	aCanvas line: self bottomLeft to: innerRectangle bottomLeft color: Color grey.
	aCanvas line: self topRight to: innerRectangle topRight color: Color grey.
	aCanvas line: self bottomRight to: innerRectangle bottomRight color: Color grey! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 9/26/2005 11:19'!
drawVerticalText: aText at: aPosition

	| form |

	self paintImage: (form _ (TextMorph new contents: aText asText) imageForm rotateBy: 270) 
		at: aPosition - form boundingBox bottomCenter
! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 9/26/2005 11:20'!
drawVerticalText: aText color: aColor at: aPosition

	| form txt |

	txt _ aText asText addAttribute: (TextColor color: aColor).

	self paintImage: (form _ (TextMorph new contents: txt) imageForm rotateBy: 270) 
		at: aPosition - form boundingBox bottomCenter
! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 1/8/2006 17:44'!
editAmongChoices: choices label: aString

	| w h |

	w _ 500.
	h _ (choices lineCount * TextStyle defaultFont height) min: 300.

	^ Compiler evaluate: 
		(((FillInTheBlankMorph
		 	request: aString
 			initialAnswer: choices
			centerAt: World center 
			inWorld: World 
			onCancelReturn: (choices lineNumber: 1) 
			acceptOnCR: false 
			answerExtent: w @ h) whenEmpty: [^ nil]) lineNumber: 1)! !

!PBBooleanPreferenceView methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/2/2007 20:44'!
enabledButton
	| aButton aLabel psel |

	psel _ self preference name.

	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: (Preferences lambda preferenceAt: psel);
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue;
		yourself.
	aLabel := (StringMorph contents: 'enabled' translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).
	^self horizontalPanel
		addMorphBack: aButton;
		addMorphBack: aLabel;
		yourself.! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 8/23/2005 14:30'!
end

	^ stop! !

!String methodsFor: '*People-spfa-utils-for-menu' stamp: 'yo 11/2/2004 20:45'!
evaluate

	^ Compiler evaluate: self! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/23/2008 14:24'!
explorePointers
	PointerExplorer new openExplorerFor: self! !

!FloatArray methodsFor: '*People-spfa-utils' stamp: 'spfa 4/16/2005 11:45'!
extrema

	| tmax tmin xts |

	xts _ Set new.
	tmax _ tmin _ self at: 1.
	xts add: self size@self last.

	(1 to: self size) do: [:i |
		tmax ifNotNil:	[
			(self at: i) >= tmax 
				ifTrue: [tmax _ self at: i	]
				ifFalse: [
					xts add: (i-1)@tmax.
					tmin _ tmax.
					tmax _ nil
				]].
		tmin ifNotNil: [
			(self at: i) <= tmin 
				ifTrue: [tmin _ self at: i]
				ifFalse: [
					xts add: (i-1)@tmin.
					tmax _ tmin.
					tmin _ nil
				]]].

	^ xts asArray sortBy: [:p1 :p2 | p1 x < p2 x]! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
findBetween: aCharacter
	"Answer the collection of String tokens that result from parsing self.  Tokens are separated by aCharacter"

	| tokens keyStart keyStop |
	tokens _ OrderedCollection new.
	keyStop _ 1.
	[keyStop <= self size] whileTrue:
		[keyStart _ self skip: aCharacter from: keyStop.
		keyStop _ self indexOf: aCharacter startingAt: keyStart ifAbsent: [self size+1].
		keyStart < keyStop
			ifTrue: [tokens add: (self copyFrom: keyStart to: (keyStop - 1))]].
	^tokens! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 9/7/2005 14:03'!
findEndOfString: aString  
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	| i |

	i _ self findString: aString asString startingAt: 0 caseSensitive: false.
	i isZero ifTrue: [self error: 'no match'].
	^ i + aString size
! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 9/7/2005 14:04'!
findEndOfString: aString  
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	^ string findEndOfString: aString  
! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 10/2/2005 15:11'!
findEndOfString: aString  startingAt: index
	"Answer the index after subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	| i |

	i := self findString: aString asString startingAt: index caseSensitive: false.
	i isZero ifTrue: [self error: 'no match'].
	^ i + aString size
! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
findString: subString
	"Answer the index of subString within the receiver, starting at start. If 
	the receiver does not contain subString, answer 0."
	^self findString: subString startingAt: 1.! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 9/7/2005 14:04'!
findString: aString 
	"Answer the index of subString within the receiver, starting at 0. If the receiver does not contain subString, raise an error."

	^ string findString: aString  
! !

!Bag class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/14/2005 11:01'!
flatten: aCollection

	| fc | 

	fc _ self new.

	aCollection do: [:el |
		el isCollection 
			ifTrue: [fc addAll: el]
			ifFalse: [fc add: el]].

	^ fc! !

!Bag class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/14/2005 11:01'!
flattenDeeply: aCollection

	| fc | 

	fc _ self new.

	aCollection do: [:el |
		el isCollection 
			ifTrue: [fc addAll: (self flattenDeeply: el)]
			ifFalse: [fc add: el]].

	^ fc! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 10/4/2005 13:58'!
forceIn: anInterval

	^ (self max: anInterval start) min: anInterval end! !

!MessageSend methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/17/2005 14:27'!
fork

	[self value] fork! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
fromB64

	"'SGkgVGhlcmUh' fromB64"

	| ss |

	ss _ ReadWriteStream on: (String new).
	ss nextPutAll: self.

 	^ (Base64MimeConverter mimeDecodeToChars: ss) contents ! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/14/2005 18:00'!
fromLocalFileName: aString

 	^ (MultiByteBinaryOrTextStream with: ((FileStream readOnlyFileNamed: (FileDirectory default fullNameFor: aString)) binary contentsOfEntireFile)) binary reset fileInObjectAndCode openInWorld.
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/14/2005 10:48'!
getCopyButton

	| label |

	label _ (FillInTheBlank request: 'button label:' initialAnswer: self buttonName) 
				whenEmpty: [^ self].

	(MenuMorph new add: ('+ ', label) target: self action: #openCopyInHand)
		stayUp: true; openInHand! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/31/2004 22:09'!
getProperty: aSymbol

	self setProperty: aSymbol
		  toValue: true
					! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 2/2/2004 20:49'!
getReference

	"create a ghost-like TransferMorph with self as passenger and give it to the Hand"

	^ (TransferMorph withPassenger: self) 
		color: Color transparent;
		extent: self extent;
		addMorph: self imageForm reverse asMorph;
		source: self;
		openInHand! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 17:13'!
handlesMouseDown: evt
	^ true! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 3/10/2004 13:31'!
handlesMouseOver: evt

	^ true! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:41'!
hasSubMenu
	"Return true if the receiver has a submenu"
	^ self subMenu notNil! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:41'!
hasSubMenu: aMenuMorph
	self subMenu ifNil:[^false].
	self subMenu == aMenuMorph ifTrue:[^true].
	^ self subMenu hasSubMenu: aMenuMorph! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2005 13:41'!
hasUsualFile

	^ self hasProperty: #lastFileNameWhenSaved! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 4/11/2005 11:41'!
height: aNumber

	^ self origin corner: self corner x @ (self corner y + aNumber)! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/23/2003 14:06'!
idString
	"return a string used to identify this morph in a part bin menu, or nil if this morph is not supposed to be available from there"

	^ nil! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/17/2005 20:38'!
ifNotNilOr: anObject ifBothNotNil: aBlock

	anObject ifNil: [^ self].
	^ aBlock value! !

!UndefinedObject methodsFor: '*People-spfa-utils' stamp: 'spfa 11/17/2005 20:38'!
ifNotNilOr: anObject ifBothNotNil: aBlock

	^ anObject! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 11/17/2005 20:49'!
ifNotNilOr: anObject ifBothNotNilAndDifferent: aBlock

	anObject ifNil: [^ self].
	(anObject closeTo: self) ifTrue: [^ self].
	^ aBlock value! !

!UndefinedObject methodsFor: '*People-spfa-utils' stamp: 'spfa 11/17/2005 20:50'!
ifNotNilOr: anObject ifBothNotNilAndDifferent: aBlock

	^ anObject ! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 3/11/2004 09:15'!
initialize

	super initialize.
	self color: (Color white alpha: 0.7);
		 extent: 100@100;
		borderColor: Color red;
		borderWidth: 3.
		
	self setProperty: #creationTime toValue: Time now
	! !

!PBPreferenceButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 1/25/2007 22:04'!
initializeWithPreference: aPreference model: aModel
	
	| psel |

	psel _ aPreference name.

	preference := Preferences lambda preferenceAt: psel.
	model := aModel.
	self initializeLayout.
	self addMorphBack: self preferenceMorphicView.
	self highlightOff.! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/10/2003 11:35'!
instanceInfoLine

	"displayed by the instances browser"

	^ self printString! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 4/10/2003 15:09'!
instanceInfoText

	"displayed by the instances browser"

	| txt |

	txt _ ''.

	self isMorph ifTrue:
		[txt _ txt,  'in project: ', (self world ifNil: ['<NONE>']
												ifNotNil: [self world project name]), 
									String cr,
					  'owner: ', self owner asString, String cr].

	^ txt, 'known name: ', self knownName asString! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 15:05'!
instanceTypes
	"return nil or a dictionary providing different instance creation methods (values) associated to their names (keys), so that we can register different types of the morph in a part bin or a menu"

	^ nil! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/15/2006 13:30'!
instanceTypesMenu

	| m |

	m _ MenuMorph new.

	self instanceTypes keysAndValuesDo: [:k : val |
		m add: k lambda: (self lambda: val) openInHand].			

	^ m

! !

!FloatArray methodsFor: '*People-spfa-utils' stamp: 'spfa 5/3/2007 22:05'!
interpolateAt: aNumber

	| dy x n vn vnp |

	dy _ self last - self first.

	dy isZero ifTrue: [^ 0].

	x _ aNumber * (self size -1).
	n _ x asInteger.
	vn _ self at: n + 1.
	n + 1 = self size ifTrue: [^ vn].
	vnp _ self at: n + 2.
	^ (vn + ((x - n) * (vnp - vn)) - self first) / dy
	! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 3/12/2007 15:07'!
invokeWithEvent: evt
	"Perform the action associated with the given menu item."

	| selArgCount w |
	self isEnabled ifFalse: [^ self].
	target class == HandMorph ifTrue: [(self notObsolete) ifFalse: [^ self]].
	owner ifNotNil:[self isStayUpItem ifFalse:[
		self flag: #workAround. "The tile system invokes menus straightforwardly so the menu might not be in the world."
		(w _ self world) ifNotNil:[
			owner deleteIfPopUp: evt.
			"Repair damage before invoking the action for better feedback"
			w displayWorldSafely]]].
	selector ifNil:[^self].
	Cursor normal showWhile: [  "show cursor in case item opens a new MVC window"
		(selArgCount _ selector numArgs) = 0
			ifTrue:
				[target perform: selector]
			ifFalse:
				[selArgCount = arguments size
					ifTrue: [target perform: selector withArguments: arguments]
					ifFalse: [target perform: selector withArguments: (arguments copyWith: evt)]]].

	owner notNil 
		ifTrue: [owner doThen]
	! !

!Array methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 5/30/2006 23:24'!
isArray

	^ true! !

!Object methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 5/30/2006 23:24'!
isArray

	^ false! !

!Canvas methodsFor: '*People-spfa-utils' stamp: 'spfa 4/4/2008 15:37'!
isFormCanvas

	^ false! !

!FormCanvas methodsFor: '*People-spfa-utils' stamp: 'spfa 4/4/2008 15:37'!
isFormCanvas

	^ true! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 13:25'!
isMenu

	^ true! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/30/2005 13:25'!
isMenu

	^ false! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 5/26/2008 23:02'!
isPrime
	"See isProbablyPrimeWithK:andQ: for the algoritm description."
	| k q |
	self <= 1 ifTrue: [^self error: 'operation undefined'].
	self even ifTrue: [^self = 2].
	k := 1.

	q := self - 1 bitShift: -1.
	[q odd] whileFalse: 
			[q := q bitShift: -1.
			k := k + 1].
	
	25 timesRepeat: [(self isProbablyPrimeWithK: k andQ: q) ifFalse: [^false]].
	^true! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 5/26/2008 23:02'!
isProbablyPrimeWithK: k andQ: q 
	"Algorithm P, probabilistic primality test, from
	Knuth, Donald E. 'The Art of Computer Programming', Vol 2,
	Third Edition, section 4.5.4, page 395, P1-P5 refer to Knuth description."

	"P1"

	| x j y |
	x := (self - 2) atRandom + 1.
	"P2"
	j := 0.
	y := x raisedToInteger: q modulo: self.
	"P3"
	
	[(((j = 0) & (y = 1)) | (y = (self - 1))) ifTrue: [^true].
	((j > 0) & (y = 1)) ifTrue: [^false].	"P5"
	true]  
			whileTrue: 
				[j := j + 1.
				(j < k) ifTrue: [y := y squared \\ self]
				ifFalse:[^ false]]! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 4/2/2005 21:47'!
isSortedAccordingTo: aSortBlock

	"
		#(1 2 3 4 5) isSortedAccordingTo: [:v1 :v2 | v1 < v2]
		#(1 7 3 4 5) isSortedAccordingTo: [:v1 :v2 | v1 < v2]
	"

	self allButLast withIndexDo: [:v :i |
		(aSortBlock value: v value: (self at: i + 1)) ifFalse: [^ false]].

	^ true! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2007 14:54'!
isTransferMorph

	^ false! !

!TransferMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2007 14:54'!
isTransferMorph

	^ true! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:41'!
itemWithWording: wording
	"If any of the receiver's items or submenu items have the given wording (case-blind comparison done), then return it, else return nil."
	(self contents asString sameAs: wording) ifTrue:[^self].
	self subMenu ifNotNil:[^self subMenu itemWithWording: wording].
	^nil! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 9/19/2005 09:19'!
label: aStringOrMessageSend

	self removeAllMorphs.
	self addMorph: ((self morphForLabel: aStringOrMessageSend) 
						borderWidth: 1;
						margins: 2;
						centered;
						autoFit: true;
						backgroundColor: (Color thistle muchLighter alpha: 0.9); 
						center: self bounds bottomCenter)! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/13/2004 10:19'!
label: aString
	label _ aString! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/7/2008 10:26'!
lambdaParseArgumentFor: aSelector inBehalfOf: anObject withString: aString initialAnswer: stringOrSymbol then: cSelector

	| str |

	aSelector ifNil: [^ self].

	str _ FillInTheBlank request: aString 
			initialAnswer: 
				(stringOrSymbol isSymbol 
					ifTrue: [(anObject perform: stringOrSymbol) printString] 					ifFalse: [stringOrSymbol]) .
	str ifEmpty: [^ self].

	anObject perform: aSelector withArguments: {Lambda parse: str}.
	cSelector isSymbol
		ifTrue: [defaultTarget perform: cSelector]
		ifFalse: [cSelector value] 
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/16/2004 09:50'!
leftCenter: aPoint

	self center: aPoint.
	self left: aPoint x! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2006 20:37'!
lines

	^ self linesCollect: [:line | line]! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 1/8/2006 17:34'!
linesCollect: aBlock
	"execute aBlock with each line in this string.  The terminating CR's are not included in what is passed to aBlock"
	| start end collection |
	start _ 1.
	collection _ OrderedCollection new.
	[ start <= self size ] whileTrue: [
		end _ self indexOf: Character cr  startingAt: start  ifAbsent: [ self size + 1 ].
		end _ end - 1.

		collection add: (aBlock value: (self copyFrom: start  to: end)).
		start _ end + 2. ].

	^ collection asArray! !

!PBBooleanPreferenceView methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 1/25/2007 21:35'!
localToProjectButton
	| aButton aLabel psel |

	psel _ self preference name.

	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: (Preferences lambda preferenceAt: psel);
		actionSelector: #toggleProjectLocalness;
		getSelector: #localToProject;
		yourself.
	aLabel := (StringMorph contents: 'local' translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).		
	^self horizontalPanel
		addMorphBack: aButton;
		addMorphBack: aLabel;
		yourself.! !

!Float methodsFor: '*People-spfa-utils' stamp: 'spfa 12/19/2005 21:02'!
log2
	"Answer the base 2 logarithm of the receiver."

	^ self ln / Ln2! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 2/8/2007 11:07'!
makeGetterSetterWordingFrom: anAssociation

	anAssociation value ifNil: [^ anAssociation key].

	anAssociation key ifEmpty: [^ anAssociation value value stringForMenu].

	^ anAssociation key, ': ', anAssociation value value stringForMenu! !

!MouseInputArea class methodsFor: 'utilities' stamp: 'spfa 3/11/2004 10:31'!
makeHalo: aRectangle with: anArrayOfAssociations color: aColor

	anArrayOfAssociations 
	with: 
	({	 #bottomRight: -> #topLeft.
	 	 #bottomLeft: -> #topRight.
	      #topRight: -> #bottomLeft.
	 	 #topLeft: -> #bottomRight} first: anArrayOfAssociations size) 
	do: 
	[:assoc :cop |
		(self new)
			beTemporary; beSmall; 
			perform: cop key with: (aRectangle perform: cop value);
			messageSend: assoc value;
			smallLabel: assoc key;
			borderColor: aColor;
			openInWorld]


			
	! !

!DropReporter class methodsFor: 'utilities' stamp: 'spfa 5/15/2006 14:51'!
makeHaloTargetting: aMorph withSelectors: anArrayOfAssociations color: aColor

	self makeHalo: aMorph bounds
		with: (anArrayOfAssociations
				collect: [:a | a key -> (aMorph lambda: a value)])
		color: aColor 


! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 2/9/2007 11:05'!
makeLambdaFrom: aSymbolOrLambda

	aSymbolOrLambda ifNil: [^ nil].

	 aSymbolOrLambda isSymbol 
		ifTrue: [^ defaultTarget lambda: aSymbolOrLambda].

	aSymbolOrLambda isMessageSend ifFalse: [self error: 'unproper object'].

	^ aSymbolOrLambda asLambdaMessageSend! !

!UpdatingStringMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2007 22:41'!
maximumWidth: aNumber

	maximumWidth _ aNumber! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
messageSend: aMessageSend

	messageSend _ aMessageSend! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 4/4/2008 17:21'!
mod2Pi

	 ^ self \\ 6.283185307179586
! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 3/23/2004 14:47'!
modPi

	^ self \\ Float pi! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:29'!
moduleIn: anInterval

	| xt x|

	x _ self.
	xt _ anInterval extent.
	x > anInterval last ifTrue: [xt _ xt negated].
	[anInterval rangeIncludes: x]
		whileFalse: [x _ x + xt].
	^ x 

	! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 4/24/2008 11:34'!
morphForLabel: aStringOrMessageSend

	^ aStringOrMessageSend isString
		ifTrue: [TextMorph new 
					contents: aStringOrMessageSend asBoldText;
					color: Color darkGray]
		ifFalse: [UpdatingTextMorph on: aStringOrMessageSend]
	! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 17:11'!
mouseDown: evt
	"Wait for a double-click"
	evt hand waitForClicksOrDrag: self event: evt.

	^super mouseDown: evt
! !

!SensitiveArea methodsFor: 'event handling' stamp: 'spfa 12/3/2005 16:06'!
mouseEnter: evt

	self flash.
	messageSend value.
	self temporary ifTrue: [0.1 exactSeconds asDelay wait. self delete].
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:42'!
mouseLeaveDragging: evt 
	"The mouse left the receiver. Do nothing if we're not in a 'valid menu transition', meaning that the current hand focus must be aimed at the owning menu."

	owner ifNil: [^self].
	evt hand mouseFocus == owner ifFalse: [^self].
	"If we have a submenu, make sure we've got some time to enter it before actually leaving the menu item"
	self subMenu isNil 
		ifTrue: [owner selectItem: nil event: evt]
		ifFalse: 
			[self 
				addAlarm: #deselectTimeOut:
				with: evt
				after: 500]! !

!ThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
mouseUp: evt
	"Allow on:send:to: to set the response to events other than actWhen"
	actWhen == #buttonUp ifFalse: [^super mouseUp: evt].

	(self containsPoint: evt cursorPoint) ifTrue: [
		self state: #on.
		self doButtonAction: evt
	] ifFalse: [
		self state: #off.
		target ifNotNil: [target lambdaValue mouseUpBalk: evt]
	].
	"Allow owner to keep it selected for radio buttons"
! !

!Morph class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/23/2003 13:51'!
newOpenInHand

	^ self new openInHand! !

!CollapsedMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2004 22:16'!
newSansCloseBox

	^ (self basicNew) wantsCloseBox: false; initialize
	
! !

!Random methodsFor: '*People-spfa-utils' stamp: 'spfa 12/1/2005 20:11'!
nextWithin: anInterval
	"Answer a random number in the specified interval"

	^ (self next * anInterval width) + anInterval ordered start! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 12/21/2005 09:55'!
noWeakTarget

	"binding the target in extension ensure that it is never weakly copied"

	self setProperty: #noWeakTarget toValue: target
	! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
nonEmptylines

	^ self findBetween: Character cr
! !

!UpdatingTextMorph class methodsFor: '*People-spfa-utils' stamp: 'spfa 9/19/2005 09:17'!
on: aMessageSend

	^ self on: aMessageSend receiver selector: aMessageSend selector ! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/12/2007 14:13'!
onCategoriesAndMethodsOf: aClass build: aBlock

	^ self onMethodsOf: aClass inCategories: aClass organization categories build: aBlock


		! !

!MenuMorph class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/12/2007 14:12'!
onMethodsOf: aClass inCategories: anArray build: aBlock

	| m |

	m _ self new.

	(anArray select: [:cat | 
		(aClass organization listAtCategoryNamed:  cat) notEmpty])
	do: [:cat | | catm |
		catm _ self new.
		(aClass organization listAtCategoryNamed:  cat) do: [:sel |
			aBlock value: catm value: sel].
		m add: cat subMenu: catm].

	^ m
		! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
openB64InWorkspace

	"'SGkgVGhlcmUh' openB64InWorkspace"

	self fromB64 displayWithLabel: 'code'! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/13/2003 11:47'!
openCopyInHand

	self veryDeepCopy openInHand! !

!Text methodsFor: '*People-spfa-utils' stamp: 'spfa 5/6/2003 11:49'!
openInWorkspaceWithTitle: aTitle
	"Open up a workspace with the receiver as its contents, with the given title"

	(Workspace new contents: self) openLabel: aTitle! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/11/2004 09:51'!
openNearHand

	(self bottomRight: (self currentHand position - (10@10))) openInWorld! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 12/1/2005 20:11'!
ordered

	start > stop ifTrue: [^ stop to: start by: step negated]! !

!SystemWindow methodsFor: '*People-spfa-utils-override' stamp: 'spfa 11/30/2004 23:03'!
paneColor
	| cc |
	(cc := self valueOfProperty: #paneColor) ifNotNil: [^cc].
	Display depth > 2 
		ifTrue: 
			[model ifNotNil: 
					[model isInMemory 
						ifTrue: 
							[cc := Color colorFrom: model defaultBackgroundColor.
							Preferences alternativeWindowLook 
								ifTrue: 
									[cc := (cc = Color lightYellow or: [cc = Color white]) 
										ifTrue: [Color gray: 0.67]
										ifFalse: [cc asColor duller]]]].
			cc 
				ifNil: [cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color]]].
	cc ifNil: [cc := self defaultBackgroundColor].
	self paneColor: cc.
	^cc! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/1/2005 11:32'!
preciseExtent

	^ (self valueOfProperty: #preciseExtent) ifNil: [self extent]
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/1/2005 11:32'!
precisePosition

	^ (self valueOfProperty: #precisePosition) ifNil: [self position]! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 6/28/2004 15:01'!
preciselyScaleFrom: rect1 to: rect2
	"Produce a rectangle stretched according to the stretch from rect1 to rect2"
	^ (origin preciselyScaleFrom: rect1 to: rect2)
		corner: (corner preciselyScaleFrom: rect1 to: rect2)! !

!PBPreferenceButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
preference
	^preference lambdaValue! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/8/2006 22:38'!
prepareToBeSaved

	self actualSubMenu: nil! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 3/30/2008 21:07'!
printStringUpTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...'! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 12/7/2004 13:41'!
profile

	^ TimeProfileBrowser spyOn: self! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/13/2004 10:18'!
provider: anObject
	provider _ anObject! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/4/2008 11:25'!
queryArgumentFor: aSelector inBehalfOf: anObject withString: aString initialAnswer: stringOrSymbol then: cSelector

	| str |

	aSelector ifNil: [^ self].

	str _ FillInTheBlank request: aString 
			initialAnswer: 
				(stringOrSymbol isSymbol 
					ifTrue: [(anObject perform: stringOrSymbol) storeString] 					ifFalse: [stringOrSymbol]) .
	str ifEmpty: [^ self].

	anObject perform: aSelector withArguments: {Compiler evaluate: str}.
	cSelector isSymbol
		ifTrue: [defaultTarget perform: cSelector]
		ifFalse: [cSelector value] 
! !

!Utilities class methodsFor: '*People-spfa-utils' stamp: 'spfa 4/23/2005 21:37'!
queryMorph: aString target: anObject selector: aSelector 

"
	Utilities queryMorph: 'explore what ?' 
		target: ObjectExplorer new 
		selector: #openExplorerFor:
"

	(DropReporter sendMorphTo: anObject via: aSelector)
		label: aString; openInHand
! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/24/2008 10:36'!
queryMorphicArgumentFor: aLambdaExpression withString: aString initialAnswer: iLambda initialMorphicLambda: initialMorphicLambda morphDependents: anArray thenDo: lastLambda

	| o |

	o _ GenericInputMorph request: aString 
			initialAnswer: iLambda lambdaValue asString
			initialMorphicLambda: initialMorphicLambda
			morphDependents: anArray.

	o isString ifTrue:
	[ 
		o ifEmpty: [^ self].
		o _ Compiler evaluate: o
	].

	aLambdaExpression withUnlimitedEvaluation valueWithArguments: {o}.
	lastLambda value

! !

!Project class methodsFor: '*People-spfa-utils' stamp: 'spfa 9/5/2004 21:41'!
queryProject

	| selection nBack prev |
	
	selection _ (Project buildJumpToMenu: CustomMenu new) startUpLeftFlush.

	selection ifNil: [^ nil].
	(selection beginsWith: '%back') ifTrue:
		[nBack _ (selection copyFrom: 6 to: selection size) asNumber.
		prev _ CurrentProject previousProject.
		1 to: nBack-1 do:
			[:i | prev ifNotNil: [prev _ prev previousProject]].
		prev ifNotNil: [^ prev]].
	selection = #parent ifTrue:
		[^ CurrentProject parent].
	^ Project namedWithDepth: selection.
! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/19/2006 13:35'!
queryValue: aString proposed: aDefault format: aSymbol

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	when the string is empty, it defaults to aDefault

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [aDefault asString]) perform: aSymbol! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/19/2006 13:35'!
queryValue: aString proposed: aDefault format: aSymbol ifNoAnswer: aBlock

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	except when the string is empty: aBlock value is then returned

	ex: 
		Utilities queryValue: 'number:' proposed: 42 format: #asInteger
		Utilities queryValue: 'your name ?' proposed: '' format: #asString
		Utilities queryValue: 'expression:' proposed: '25+45' format: #evaluate
	"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [^ aBlock value]) perform: aSymbol! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/30/2008 13:19'!
queryValueOrCancel: aString proposed: aDefault format: aSymbol

	"ask the user for the new value of aDefault.
	aSymbol is sent to the resulting string 
	when the string is empty return nil"

	^ ((self request: aString
 				 			initialAnswer: (aDefault asString)) 
		whenEmpty: [^ nil]) perform: aSymbol! !

!Point class methodsFor: '*People-spfa-utils' stamp: 'spfa 3/28/2003 23:04'!
r: rho theta: theta
	"Answer an instance of me with polar coordinates rho and theta."

	^self new setR: rho radians: theta! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:37'!
radiansToMIDI: angle

	^ (self scaleFromAngle: angle to: (0 to: 127)) rounded! !

!Integer methodsFor: '*People-spfa-utils-3.8' stamp: 'spfa 5/26/2008 23:03'!
raisedToInteger: exp modulo: m
	(exp = 0) ifTrue: [^ 1].
	exp even
		ifTrue: [^ (self raisedToInteger: (exp // 2) modulo: m) squared \\ m]
		ifFalse: [^ (self * (self raisedToInteger: (exp - 1) modulo: m)) \\ m].! !

!MouseInputArea methodsFor: 'accessing' stamp: 'spfa 3/11/2004 09:15'!
receiver: anObject selector: aSelector

	messageSend _ MessageSend receiver: anObject selector: aSelector! !

!MessageTally class methodsFor: '*People-spfa-utils' stamp: 'spfa 6/1/2004 19:29'!
reportSpyOn: aBlock 
	| node report |
	node _ self new.
	node spyEvery: self defaultPollPeriod on: aBlock.
	report _ node tally isZero 
				ifTrue:[''] 
				ifFalse: [String streamContents: [:s | node report: s; close]].
	^ report! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/19/2006 13:41'!
request: aString

	"
Utilities request: 'What do you think ?'
"

	^ self request: aString initialAnswer: '


' ! !

!Utilities class methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/23/2006 09:48'!
request: aString initialAnswer: bString 

	"fast replacement for FillInTheBlank similar method. Got tired of the tiny window..."

	| w h |

	w _ 500.
	h _ ((bString lineCount + 2)* TextStyle defaultFont height) min: 300.

	^ (FillInTheBlankMorph
		 	request: aString
 			initialAnswer: bString
			centerAt: ActiveHand cursorPoint 
			inWorld: World 
			onCancelReturn: '' 
			acceptOnCR: false 
			answerExtent: w @ h) whenEmpty: [^ '']! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/16/2004 09:50'!
rightCenter: aPoint

	self center: aPoint.
	self right: aPoint x! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/3/2005 10:59'!
ripApart

	self delete.
! !

!PasteUpMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 3/3/2005 14:52'!
ripApart

	self delete.
	self stopSteppingSelfAndSubmorphs.
	self submorphs do: [:m | m ripApart]! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2005 13:44'!
saveOnFileRememberWhere

	| aFileName fileStream ok |

	self hasUsualFile
		ifTrue: [aFileName _ self usualFile]
		ifFalse: [aFileName _ self defaultFileName].

	aFileName _ FillInTheBlank 
			request: ('File name for ''', (self knownName ifNil:[self name]) , ''' ?' )
			initialAnswer: aFileName.
	aFileName size == 0 ifTrue: [^ self].

	self allMorphsDo: [:m | m prepareToBeSaved].

	ok _ aFileName endsWith: '.morph'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.morph'].

	self setProperty: #lastFileNameWhenSaved toValue: aFileName.

	fileStream _ FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2005 13:43'!
saveOnUsualFile

	|  fileStream |

	self hasUsualFile	ifFalse: [^ self saveOnFileRememberWhere].
	
	fileStream _ FileStream fileNamed: self usualFile.					
	fileStream ifNil: [^ self saveOnFileRememberWhere].
						
	self allMorphsDo: [:m | m prepareToBeSaved].
	fileStream fileOutClass: nil andObject: self.! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:16'!
scaleFrom: anInterval to: anotherInterval

	^ (anotherInterval extent * ((self forceIn: anInterval) - anInterval first) / anInterval extent) + anotherInterval first! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2003 21:32'!
scaleFromAngle: aNumber to: anInterval

	| intv |

	intv _ aNumber to: (aNumber + Float twoPi).

	^ (self moduleIn: intv) scaleFrom: intv to: anInterval! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/1/2004 09:21'!
segmentsCollect: aBlock 
	"Evaluate aBlock with my elements taken two at a time: each element with its immediate follower. See also segmentsDo:"

	^ (1 to: self size - 1) collect:
		[:index | aBlock value: (self at: index) value: (self at: index + 1)]
! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 11/1/2004 09:20'!
segmentsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time: each element with its immediate follower. See also segmentsCollect:"

	1 to: (self size - 1) do:
		[:index | aBlock value: (self at: index) value: (self at: index + 1)]
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 20:26'!
select: evt

	self isSelected: true.
	self hasSubMenu ifTrue: [self deleteSubMenu].
	owner activeSubmenu: self subMenu.
	self subMenu ifNotNil: [
		self subMenu
			popUpAdjacentTo: (Array with: self bounds topRight + (10@0)
									with: self bounds topLeft)
			forHand: evt hand
			from: self.
		self subMenu selectItem: nil event: evt].! !

!SimpleServiceEntry methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/13/2004 10:18'!
selector: aSelector
	selector _ aSelector! !

!DropReporter class methodsFor: 'as yet unclassified' stamp: 'spfa 3/11/2004 09:42'!
sendMorphTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!TransferGetter class methodsFor: 'as yet unclassified' stamp: 'spfa 1/8/2006 22:09'!
sendPassengerTo: anObject via: aSelector

	^ self new receiver: anObject selector: aSelector! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 12/2/2004 13:47'!
sendToAnotherProject

	| target |
	
	target _ Project queryProject ifNil: [^ self].
	target world addMorph: self! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2004 22:24'!
setLabelWidgetAllowance

	self wantsCloseBox ifTrue: [^ super setLabelWidgetAllowance].

	^ labelWidgetAllowance :=  (self boxExtent x * 2) + 19! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 4/7/2003 18:03'!
setProperty: aSymbol toValue: anObject then: bSymbol

	self setProperty: aSymbol
		  toValue: anObject.

	self perform: bSymbol
					! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2007 20:37'!
setX: aValue
	x _ aValue
! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 9/27/2005 19:03'!
setXY: aPoint

	x _ aPoint x.
	y _ aPoint y! !

!Point methodsFor: '*People-spfa-utils' stamp: 'spfa 3/13/2007 20:38'!
setY: aValue
	y _ aValue
! !

!Random methodsFor: '*People-spfa-utils' stamp: 'spfa 8/26/2005 14:49'!
sign
	"Answer 1 or -1"

	^ (self nextWithin: (-10 to: 10)) sign! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
skip: aCharacter from: start 
	"Answer the index of the character within the receiver, starting at start, that does NOT match aCharacter. If the receiver does not contain any aCharacter answer size + 1. "

	start to: self size do: [:i | aCharacter = (self at: i) ifFalse: [^ i]].
	^ self size + 1! !

!MouseInputArea methodsFor: 'private' stamp: 'spfa 9/19/2005 09:18'!
smallLabel: aStringOrMessageSend

	self removeAllMorphs.
	self addMorph: ((self morphForLabel: aStringOrMessageSend) 
						borderWidth: 0;
						margins: 1;
						centered;
						autoFit: true;
						backgroundColor: Color transparent; 
						center: bounds center;
						bottom: bounds bottom)! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2004 14:23'!
smallThumbnailForPageSorter

	^ (BookPageThumbnailMorph new smaller) page: self! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 21:38'!
spaceProfile

	^ SpaceTally analyseDifferenceAfter: self! !

!BlockContext methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 22:27'!
spaceProfileClasses: classes

	^ SpaceTally analyseDifferenceAfter: self forClasses: classes! !

!SpaceTally methodsFor: '*People-spfa-utils' stamp: 'spfa 3/9/2005 21:52'!
spaceTally: classes progressSays: aString

	self preAllocateResultsFor: classes.
	Smalltalk garbageCollect.
	self computeSpaceUsageWithProgress: aString.
	^ results
! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 8/23/2005 14:30'!
start

	^ start! !

!EtoyUpdatingThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
step
	| newBoolean |

	state == #pressed ifTrue: [^ self].
	newBoolean _ target lambdaValue perform: getSelector withArguments: arguments.
	newBoolean == self isOn
		ifFalse:
			[self state: (newBoolean ifTrue: [#on] ifFalse: [#off])]
! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 12/3/2005 16:05'!
step

	(self temporary
		and: [Time now >= (1.5 exactSeconds + (self valueOfProperty: #creationTime))])
		ifTrue: [self delete]
		
! !

!UpdatingThreePhaseButtonMorph methodsFor: '*People-spfa-utils-lambda' stamp: 'spfa 2/10/2007 15:38'!
step
	| newBoolean |
	super step.
	state == #pressed ifTrue: [^ self].
	newBoolean _ target lambdaValue perform: getSelector.
	newBoolean == self isOn
		ifFalse:
			[self state: (newBoolean == true ifTrue: [#on] ifFalse: [#off])]! !

!MouseInputArea methodsFor: 'stepping' stamp: 'spfa 3/11/2004 09:15'!
stepTime

	^ 100
		
! !

!Float methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 10:33'!
stringForMenu

	^ self withMenuPrecision asString! !

!Object methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/15/2007 18:21'!
stringForMenu

	^ self printString contractTo: 30! !

!Point methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 10:34'!
stringForMenu

	^ self withMenuPrecision asString! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:40'!
subMenu

	"subMenu may be a MessageSend, so use #value"

	self actualSubMenu ifNil: [self actualSubMenu: subMenu value].
	^ self actualSubMenu
! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 8/30/2005 09:31'!
subMenu: aMenuMorphOrMessageSend

	subMenu _ aMenuMorphOrMessageSend.
	self actualSubMenu: nil.
	self changed.
! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
substringsWithSeparators: aString
	"Answer an array of the substrings that compose the receiver."
	| result end beginning separators nonseparators |

	result _ WriteStream on: (Array new: 10).

	separators _ CharacterSet newFrom: aString.
	nonseparators _ separators complement.

	end _ 0.
	"find one substring each time through this loop"
	[ 
		"find the beginning of the next substring"
		beginning _ self indexOfAnyOf: nonseparators startingAt: end+1 ifAbsent: [ nil ].
		beginning ~~ nil ] 
	whileTrue: [
		"find the end"
		end _ self indexOfAnyOf: separators startingAt: beginning ifAbsent: [ self size + 1 ].
		end _ end - 1.

		result nextPut: (self copyFrom: beginning to: end).

	].


	^result contents! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 10/2/2005 15:23'!
substringsWithStringSeparator: aString
	"Answer an array of the substrings that compose the receiver."
	| result end beginning s |

	result := WriteStream on: (Array new: 10).

	end := 0.
	beginning := 1.
	[ 
		end := self findString: aString startingAt: beginning.
		s _ self copyFrom: beginning 
								to: (end isZero ifTrue: [self size] ifFalse: [end - 1]).
		s ifNotEmpty: [result nextPut: s].
		end isZero not] 
	whileTrue: [beginning := self findEndOfString: aString startingAt: end	].

	^result contents! !

!String methodsFor: '*People-spfa-utils' stamp: 'yo 11/2/2004 20:45'!
surroundedByDoubleQuotes
	"Answer the receiver with leading and trailing quotes.  "

	^ $" asString, self, $" asString! !

!Class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/20/2003 15:32'!
symbol

	^ self asString asSymbol! !

!MouseInputArea methodsFor: 'testing' stamp: 'spfa 3/11/2004 09:15'!
temporary

	^ self hasProperty: #temporary.
	
	! !

!Process class methodsFor: '*People-spfa-utils' stamp: 'spfa 10/22/2004 20:36'!
terminateAllNamed: aString

	^ (self allNamed: aString) do: [:p | p terminate]! !

!MenuMorph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/27/2005 23:28'!
thenAction: aMessageSendOrASelector

	self setProperty: #then toValue: aMessageSendOrASelector
! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 2/6/2004 14:23'!
thumbnailForPageSorter

	^ (BookPageThumbnailMorph new) page: self! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 4/2/2008 22:21'!
timeProfileDisplay

	| canvas |

	canvas _ FormCanvas extent: 2000@1000.
	TimeProfileBrowser spyOn: [100 timesRepeat: [self drawOn: canvas]].
! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/11/2003 16:46'!
toggleProperty: aSymbol

	self setProperty: aSymbol
		  toValue: ((self hasProperty: aSymbol) not)
					! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 9/11/2005 13:55'!
toggleProperty: aSymbol then: bSymbol

	self toggleProperty: aSymbol.
	self perform: bSymbol

					! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 6/16/2004 09:51'!
topCenter: aPoint

	self center: aPoint.
	self top: aPoint y! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 8/21/2005 10:33'!
topMostOwner
	
	^ (self ownerChain select: [:m | m notNil]) last! !

!Float class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/31/2003 15:49'!
twoPi

	^ Twopi! !

!String methodsFor: '*People-spfa-utils' stamp: 'spfa 8/29/2008 22:54'!
unCamelled
	| stream  |
	stream _ WriteStream on: (self species new: self size * 2).
	self do: [ :c |
		c isUppercase 
			ifTrue: [ stream nextPut: $ ; nextPut: c asLowercase ]
			ifFalse: [ stream nextPut: c ].
	].
	^stream contents! !

!Interval class methodsFor: '*People-spfa-utils' stamp: 'spfa 8/24/2005 14:49'!
unbound
	
	^ Float infinity negated to: Float infinity! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 5/14/2004 20:37'!
uncollapsedMorph
	^uncollapsedMorph! !

!Rectangle class methodsFor: '*People-spfa-utils' stamp: 'spfa 5/7/2003 14:02'!
unit

	^ (0@0) corner: (1@1)! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 1/7/2005 18:15'!
updateBox: anIconMorph color: aColor 

	(self wantsCloseBox not
		and: [anIconMorph == closeBox]) ifTrue: [^ self].	
			
	super 	updateBox: anIconMorph color: aColor ! !

!Morph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/21/2005 13:40'!
usualFile

	^ self valueOfProperty: #lastFileNameWhenSaved! !

!MenuItemMorph methodsFor: '*People-spfa-utils-for-menu-override' stamp: 'spfa 2/4/2007 10:08'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied  
	at all, but shared. Warning!!!! Every instance variable defined in  
	this class must be handled. We must also implement  
	veryDeepFixupWith:. See DeepCopier class comment."
	super veryDeepInner: deepCopier.
	isEnabled := isEnabled veryDeepCopyWith: deepCopier.
	subMenu := subMenu veryDeepCopyWith: deepCopier.
	isSelected := isSelected veryDeepCopyWith: deepCopier.
	icon := icon veryDeepCopyWith: deepCopier.
	"target := target.		Weakly copied"
	"selector := selector.		a Symbol"
	arguments := arguments veryDeepCopyWith: deepCopier.! !

!TranscriptStream methodsFor: '*People-spfa-utils' stamp: 'spfa 3/2/2005 12:10'!
visible

	"Transcript visible show: 'hello'"

	World findATranscript: nil.! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2004 22:10'!
wantsCloseBox
	
	^ (self hasProperty: #noCloseBox) not! !

!CollapsedMorph methodsFor: '*People-spfa-utils' stamp: 'spfa 10/28/2004 22:10'!
wantsCloseBox: aBoolean
	
	self setProperty: #noCloseBox toValue: aBoolean not! !

!Morph methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 8/29/2005 22:35'!
wantsDroppedMenu

	^ false! !

!DropReporter methodsFor: 'event handling' stamp: 'spfa 5/8/2003 15:33'!
wantsDroppedMorph: dropee event: evt

	^ true
		
! !

!TransferGetter methodsFor: 'as yet unclassified' stamp: 'spfa 2/6/2007 14:56'!
wantsDroppedMorph: dropee event: evt

	^ dropee isTransferMorph
		! !

!TranscriptStream methodsFor: '*People-spfa-utils' stamp: 'spfa 3/2/2005 12:11'!
warn: anObject

	self visible cr; show: anObject; cr.! !

!Collection methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 1/26/2004 20:17'!
whenEmpty: aBlock

	^ self isEmpty ifTrue: aBlock ifFalse: [self]! !

!Interval methodsFor: '*People-spfa-utils' stamp: 'spfa 8/26/2005 14:08'!
width

	^ (stop - start) abs! !

!Rectangle methodsFor: '*People-spfa-utils' stamp: 'spfa 1/24/2003 09:43'!
width: aNumber

	^ self origin corner: (self origin x + aNumber) @ self corner y! !

!Symbol methodsFor: '*People-spfa-utils' stamp: 'spfa 12/19/2004 10:09'!
with: anArray

	anArray isCollection ifFalse: [^ self with: {anArray}].
	anArray size = self arity ifFalse:
		[^ self error: 'size mismatch']. 

	^ Message selector: self arguments: anArray! !

!SequenceableCollection methodsFor: '*People-spfa-utils' stamp: 'spfa 12/4/2004 10:25'!
with: otherCollection withIndexDo: threeArgBlock 
	"Evaluate threeArgBlock with corresponding elements from this collection and otherCollection plus their common index."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		threeArgBlock value: (self at: index)
						value: (otherCollection at: index)
						value: index]! !

!Object methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 5/22/2006 10:32'!
withMenuPrecision

	^ self precision: 3! !

!String methodsFor: '*People-spfa-utils-for-menu' stamp: 'spfa 3/11/2007 14:12'!
withMenuPrecision

	^ self precision: 30! !

!Object methodsFor: '*People-spfa-utils' stamp: 'spfa 9/19/2005 20:31'!
withMuOPrecision

	^ self precision: MuO precision! !

!Preferences class methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2006 17:54'!
withPreference: prefSymbol do: aBlock

	self withPreference: prefSymbol setToValue: true do: aBlock! !

!Preferences class methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2006 17:53'!
withPreference: prefSymbol setToValue: aBoolean do: aBlock

	| cval |

	cval _ self perform: prefSymbol.
	self setPreference: prefSymbol toValue: aBoolean.
	aBlock value.
	self setPreference: prefSymbol toValue: cval! !

!Preferences class methodsFor: '*People-spfa-utils' stamp: 'spfa 1/13/2006 17:54'!
withoutPreference: prefSymbol do: aBlock

	self withPreference: prefSymbol setToValue: false do: aBlock! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2003 18:38'!
x

	"consistent with the usual graphic representation of imaginary numbers"

	^ self! !

!Number methodsFor: '*People-spfa-utils' stamp: 'spfa 5/28/2003 18:38'!
y

	"consistent with the usual graphic representation of imaginary numbers"

	^ 0! !
